md5.h File Reference

MD5 message digest algorithm (hash function) More...

`#include "mbedtls/config.h"`
`#include <stddef.h>`
`#include <stdint.h>`
Include dependency graph for md5.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Data Structures

struct | mbedtls_md5_context
| MD5 context structure. More...

## Macros

#define | MBEDTLS_ERR_MD5_HW_ACCEL_FAILED -0x002F
#define | MBEDTLS_DEPRECATED __attribute__((deprecated))
#define | MBEDTLS_DEPRECATED __attribute__((deprecated))

## Typedefs

typedef struct mbedtls_md5_context | mbedtls_md5_context
| MD5 context structure. More...

## Functions

void | mbedtls_md5_init (mbedtls_md5_context *ctx)
| Initialize MD5 context. More...
void | mbedtls_md5_free (mbedtls_md5_context *ctx)
| Clear MD5 context. More...
void | mbedtls_md5_clone (mbedtls_md5_context *dst, const mbedtls_md5_context *src)
| Clone (the state of) an MD5 context. More...
int | mbedtls_md5_starts_ret (mbedtls_md5_context *ctx)
| MD5 context setup. More...
int | mbedtls_md5_update_ret (mbedtls_md5_context *ctx, const unsigned char *input, size_t ilen)
| MD5 process buffer. More...
int | mbedtls_md5_finish_ret (mbedtls_md5_context *ctx, unsigned char output[16])
| MD5 final digest. More...
int | mbedtls_internal_md5_process (mbedtls_md5_context *ctx, const unsigned char data[64])
| MD5 process data block (internal use only) More...
MBEDTLS_DEPRECATED void | mbedtls_md5_starts (mbedtls_md5_context *ctx)
| MD5 context setup. More...
MBEDTLS_DEPRECATED void | mbedtls_md5_update (mbedtls_md5_context *ctx, const unsigned char *input, size_t ilen)
| MD5 process buffer. More...
MBEDTLS_DEPRECATED void | mbedtls_md5_finish (mbedtls_md5_context *ctx, unsigned char output[16])
| MD5 final digest. More...
MBEDTLS_DEPRECATED void | mbedtls_md5_process (mbedtls_md5_context *ctx, const unsigned char data[64])
| MD5 process data block (internal use only) More...
int | mbedtls_md5_ret (const unsigned char *input, size_t ilen, unsigned char output[16])
| Output = MD5( input buffer ) More...
MBEDTLS_DEPRECATED void | mbedtls_md5 (const unsigned char *input, size_t ilen, unsigned char output[16])
| Output = MD5( input buffer ) More...
int | mbedtls_md5_self_test (int verbose)
| Checkup routine. More...

## Detailed Description

MD5 message digest algorithm (hash function)

Warning
  MD5 is considered a weak message digest and its use constitutes a security risk. We recommend considering stronger message digests instead.

Definition in file md5.h.

## Macro Definition Documentation

## MBEDTLS_DEPRECATED [1/2]

#define MBEDTLS_DEPRECATED __attribute__((deprecated))

Definition at line 265 of file md5.h.

## MBEDTLS_DEPRECATED [2/2]

#define MBEDTLS_DEPRECATED __attribute__((deprecated))

Definition at line 265 of file md5.h.

## MBEDTLS_ERR_MD5_HW_ACCEL_FAILED

#define MBEDTLS_ERR_MD5_HW_ACCEL_FAILED -0x002F

MD5 hardware accelerator failed

Definition at line 40 of file md5.h.

## Typedef Documentation

## mbedtls_md5_context

typedef struct mbedtls_md5_context mbedtls_md5_context

MD5 context structure.

Warning
  MD5 is considered a weak message digest and its use constitutes a security risk. We recommend considering stronger message digests instead.

## Function Documentation

## mbedtls_internal_md5_process()

int mbedtls_internal_md5_process | ( | mbedtls_md5_context * | ctx,
|  | const unsigned char | data[64]
| ) |  |

MD5 process data block (internal use only)

Parameters

  ctx | MD5 context
  data | buffer holding one block of data

Returns
  0 if successful

Warning
  MD5 is considered a weak message digest and its use constitutes a security risk. We recommend considering stronger message digests instead.

## mbedtls_md5()

MBEDTLS_DEPRECATED void mbedtls_md5 | ( | const unsigned char * | input,
|  | size_t | ilen,
|  | unsigned char | output[16]
| ) |  |

Output = MD5( input buffer )

Deprecated:
  Superseded by mbedtls_md5_ret() in 2.7.0

Parameters

  input | buffer holding the data
  ilen | length of the input data
  output | MD5 checksum result

Warning
  MD5 is considered a weak message digest and its use constitutes a security risk. We recommend considering stronger message digests instead.

## mbedtls_md5_clone()

void mbedtls_md5_clone | ( | mbedtls_md5_context * | dst,
|  | const mbedtls_md5_context * | src
| ) |  |

Clone (the state of) an MD5 context.

Parameters

  dst | The destination context
  src | The context to be cloned

Warning
  MD5 is considered a weak message digest and its use constitutes a security risk. We recommend considering stronger message digests instead.

## mbedtls_md5_finish()

MBEDTLS_DEPRECATED void mbedtls_md5_finish | ( | mbedtls_md5_context * | ctx,
|  | unsigned char | output[16]
| ) |  |

MD5 final digest.

Deprecated:
  Superseded by mbedtls_md5_finish_ret() in 2.7.0

Parameters

  ctx | MD5 context
  output | MD5 checksum result

Warning
  MD5 is considered a weak message digest and its use constitutes a security risk. We recommend considering stronger message digests instead.

## mbedtls_md5_finish_ret()

int mbedtls_md5_finish_ret | ( | mbedtls_md5_context * | ctx,
|  | unsigned char | output[16]
| ) |  |

MD5 final digest.

Parameters

  ctx | MD5 context
  output | MD5 checksum result

Returns
  0 if successful

Warning
  MD5 is considered a weak message digest and its use constitutes a security risk. We recommend considering stronger message digests instead.

## mbedtls_md5_free()

void mbedtls_md5_free | ( | mbedtls_md5_context * | ctx | ) |

Clear MD5 context.

Parameters

  ctx | MD5 context to be cleared

Warning
  MD5 is considered a weak message digest and its use constitutes a security risk. We recommend considering stronger message digests instead.

## mbedtls_md5_init()

void mbedtls_md5_init | ( | mbedtls_md5_context * | ctx | ) |

Initialize MD5 context.

Parameters

  ctx | MD5 context to be initialized

Warning
  MD5 is considered a weak message digest and its use constitutes a security risk. We recommend considering stronger message digests instead.

## mbedtls_md5_process()

MBEDTLS_DEPRECATED void mbedtls_md5_process | ( | mbedtls_md5_context * | ctx,
|  | const unsigned char | data[64]
| ) |  |

MD5 process data block (internal use only)

Deprecated:
  Superseded by mbedtls_internal_md5_process() in 2.7.0

Parameters

  ctx | MD5 context
  data | buffer holding one block of data

Warning
  MD5 is considered a weak message digest and its use constitutes a security risk. We recommend considering stronger message digests instead.

## mbedtls_md5_ret()

int mbedtls_md5_ret | ( | const unsigned char * | input,
|  | size_t | ilen,
|  | unsigned char | output[16]
| ) |  |

Output = MD5( input buffer )

Parameters

  input | buffer holding the data
  ilen | length of the input data
  output | MD5 checksum result

Returns
  0 if successful

Warning
  MD5 is considered a weak message digest and its use constitutes a security risk. We recommend considering stronger message digests instead.

## mbedtls_md5_self_test()

int mbedtls_md5_self_test | ( | int | verbose | ) |

Checkup routine.

Returns
  0 if successful, or 1 if the test failed

Warning
  MD5 is considered a weak message digest and its use constitutes a security risk. We recommend considering stronger message digests instead.

## mbedtls_md5_starts()

MBEDTLS_DEPRECATED void mbedtls_md5_starts | ( | mbedtls_md5_context * | ctx | ) |

MD5 context setup.

Deprecated:
  Superseded by mbedtls_md5_starts_ret() in 2.7.0

Parameters

  ctx | context to be initialized

Warning
  MD5 is considered a weak message digest and its use constitutes a security risk. We recommend considering stronger message digests instead.

## mbedtls_md5_starts_ret()

int mbedtls_md5_starts_ret | ( | mbedtls_md5_context * | ctx | ) |

MD5 context setup.

Parameters

  ctx | context to be initialized

Returns
  0 if successful

Warning
  MD5 is considered a weak message digest and its use constitutes a security risk. We recommend considering stronger message digests instead.

## mbedtls_md5_update()

MBEDTLS_DEPRECATED void mbedtls_md5_update | ( | mbedtls_md5_context * | ctx,
|  | const unsigned char * | input,
|  | size_t | ilen
| ) |  |

MD5 process buffer.

Deprecated:
  Superseded by mbedtls_md5_update_ret() in 2.7.0

Parameters

  ctx | MD5 context
  input | buffer holding the data
  ilen | length of the input data

Warning
  MD5 is considered a weak message digest and its use constitutes a security risk. We recommend considering stronger message digests instead.

## mbedtls_md5_update_ret()

int mbedtls_md5_update_ret | ( | mbedtls_md5_context * | ctx,
|  | const unsigned char * | input,
|  | size_t | ilen
| ) |  |

MD5 process buffer.

Parameters

  ctx | MD5 context
  input | buffer holding the data
  ilen | length of the input data

Returns
  0 if successful

Warning
  MD5 is considered a weak message digest and its use constitutes a security risk. We recommend considering stronger message digests instead.